#lang sicp

(#%require "leval.rkt")

;; Definitions
(define count 0)
(define (id x)
  (set! count (+ count 1))
  x)


;; Output

;; ;;; L-Eval input:
;; (define w (id (id 10)))

;; This evaluates to:
;; (define w
;;   ((lambda (x) (set! count (+ count 1)) x)
;;    (id 10)))

;; (define w
;;   (id 10))

;; incrementing count by 1 but leaving the inner (id 10) unevaluated,
;; because we have not called for it yet.

;; ;;; L-Eval value:
;; ok

;; ;;; L-Eval input:
;; count

;; ;;; L-Eval value:
;; 1

;; ;;; L-Eval input:
;; w

;; This calls actual-value on w, which forces (id 10) to be
;; evaluated.  This returns 10 and increments count by 1 again.

;; ;;; L-Eval value:
;; 10

;; ;;; L-Eval input:
;; count

;; ;;; L-Eval value:
;; 2

;; ;;; L-Eval input:

;; Now the value of (id 10) is memoized, so any further evaluation of
;; w leaves count unchanged.
